#! /home/klotz/tkaudace/bin/audace
#
# console.tcl --
#
# Implementation d'une console d'affichage
# des resultats pour l'interface Audace
# (audace.tcl).
# Fonctionne avec la plateforme Audace.
#
# (C) 1999 Denis Marchais, Alain Klotz 
#


#############################################################################
# Visual Tcl v1.20 Project
#

#################################
# GLOBAL VARIABLES
#
global widget; 

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc {main} {argc argv} {

}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 200x200+0+0
    wm maxsize $base 320 200
    wm minsize $base 104 40
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.console {base} {
    if {$base == ""} {
        set base .console
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 640x40+10+10
    wm maxsize $base 640 480
    wm minsize $base 320 200
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Console"
    scrollbar $base.scr18 \
        -command {.console.log yview} -orient vert 
    text $base.log \
        -yscrollcommand {.console.scr18 set} 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.scr18 \
        -in .console -anchor center -expand 0 -fill y -side right 
    pack $base.log \
        -in .console -anchor center -expand 1 -fill both -side left 
}

Window show .
Window show .console

main $argc $argv
